% function to add image to a convas
function Im = addImToCanvas(im,pos,Im,template)

if ~isfloat(Im)
    Im = im2double(Im);
end
if ~isfloat(im)
    im = im2double(im);
end

if exist('template','var')~=1
    template = imread('iconTemplate.png');
end
if size(template,3)>1
    template = rgb2gray(template);
end
if ~isfloat(template)
    template = im2double(template);
end

[height,width,nChannels] = size(Im);
[h,w,foo] = size(im);

if foo~=nChannels
    error('The patch and the image must have the same dimension!');
end

[h_t,w_t,foo]=size(template);
if h_t < h+6 || w_t < w+6
    error('The template is not big enough to insert patch!');
end

% first treat shadow
x1 = pos(1); y1 = pos(2);
x2 = min(x1+w_t-1,width);
y2 = min(y1+h_t-1,height);
h_t = y2-y1+1;
w_t = x2-x1+1;

Patch = Im(y1:y2,x1:x2,:);

% add shadow
Patch = Patch.*repmat(template(1:h_t,1:w_t),[1 1 nChannels]);

% add im to the canvas
X1 = pos(1)+5; Y1 = pos(2)+5;
X2 = min(X1+w-1,width);
Y2 = min(Y1+h-1,height);
h = Y2-Y1+1;
w = X2-X1+1;
Patch(6:6+h-1,6:6+w-1,:) = im(1:h,1:w,:);

Im(y1:y2,x1:x2,:) = Patch;