function batchComputePerformance(database,M,K_array,varargin)

%--------------------------------------------------------------------------------------------------------
% set the optional parameters
%--------------------------------------------------------------------------------------------------------
paraInitial = {'method','gistL2',...
                          'epsilon',5};
                          
para = parsingVarArgIn(varargin,paraInitial(1:2:end),paraInitial(2:2:end));

parameter.method = para.method;
parameter.nCandidates = M;
parameter.epsilon = para.epsilon;
parameter.nNeighbors   = 40;
parameter.prior_weight = 0.08;
parameter.spatial_weight = 40;
parameter.isDisplay = false;
parameter.isPrint = false;
parameter.alpha = 0.7;

% K (nNeighbors): the number of nearest neighbors
% M (nCandidates): the number of candidates
for K = K_array
    if K < M
        continue;
    end
    parameter.nNeighbors = K;
    fprintf('K=%d M=%d:\n',K,M);
    paraCell = formVarargin(parameter);
    [prior_weight,spatial_weight]=objectRecogCoordDescend(database,paraCell{:});
    parameter.prior_weight = prior_weight;
    parameter.spatial_weight = spatial_weight;
    close all;
    fprintf('\n');
end