% SCRIPT TO COMPUTE THE FEATURES FOR THE DATASETS USED FOR CVPR-SIFT FLOW
% SUBMISSION 

setEnvironment(database);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% List of object classes
D = LMdatabase(setting.path.annotation);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Compute GIST
gist = LMgist(D, setting.path.images, setting.GISTparam, setting.path.gist);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Split dataset in test and training and store the indices in the root
% folder for the dataset
Nimages = length(D);
testndx = fix(linspace(1, Nimages, setting.para.nTest));
trainingndx = setdiff(1:Nimages, testndx);
save(fullfile(setting.path.database, 'splitTrainingTest.mat'), 'testndx', 'trainingndx') 
save(fullfile(setting.path.database,'database.mat'),'D','gist','testndx','trainingndx');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Create synomims and segmentations
[Dtags, unmatched] = LMaddtags(D, fullfile(setting.path.database, 'tags.txt'));

[labelmetags, counttags] = LMobjectnames(Dtags);
[counttags, n] = sort(counttags, 'descend');
labelmetags = labelmetags(n);
figure
barh(counttags)
set(gca, 'Ytick', 1:length(counttags))
set(gca, 'YTickLabel', labelmetags)

% Create segments
Dtags = LMvalidobjects(Dtags,  '-unmatched'); 
LM2segments(Dtags, [], setting.path.images, setting.path.LMsegments);


    

