% function to display the counts of objects
function dispObjCounts(database,Counts,Names,Colormap,MaxN,filename)

setting = setEnvironment(database);

if exist('MaxN','var')~=1
    MaxN = 100;
end
if exist('filename','var')~=1
    filenane = 'object_priors';
end

nClasses = length(Names);

figure;
% not many classes
if nClasses<=MaxN
    h=bar(Counts);
    colormap(Colormap);
    ch=get(h,'Children');
    fvd=get(ch,'Faces');
    fvcd=get(ch,'FaceVertexCData');
    for i=1:nClasses
        fvcd(fvd(i,:))=i;
    end
    set(ch,'FaceVertexCData',fvcd);

    set(gca,'xtick',[]);
    foo = get(gca,'YLim');
    foo = foo(2)-foo(1);
    for i=1:nClasses
        text(i,-foo*0.02,Names{i},'Rotation',270,'FontName','Times New Roman');
    end
    saveas(gcf,fullfile(setting.path.eps,[filename '.eps']),'psc2');
else
    M = ceil(nClasses/MaxN);
    for i = 1:M
        clf;
        range = (i-1)*MaxN+1:min(nClasses,i*MaxN);
        h = bar(Counts(range));
        xlim([0,MaxN+1]);
        ylim([0,max(Counts(range))*1.2]);
        map = Colormap(range,:);
        colormap(map);
        ch=get(h,'Children');
        fvd=get(ch,'Faces');
        fvcd=get(ch,'FaceVertexCData');
        for j=1:length(range)
            fvcd(fvd(j,:))=j;
        end
        set(ch,'FaceVertexCData',fvcd);
        
        set(gca,'xtick',[]);
        foo = get(gca,'YLim');
        foo = foo(2)-foo(1);
        daspect([MaxN,foo*5,1]);
        for j=1:length(range)
            text(j,-foo*0.02,Names{range(j)},'Rotation',270,'FontName','Times New Roman','FontSize',6);
        end
        
        saveas(gcf,fullfile(setting.path.eps,[filename '_' num2str(i) '.eps']),'psc2');
    end
end
close;