% function to display the per-class object recognition rate 
function dispObjRecogRate(database,performance,recogRate,Names,Colormap,MaxN,IsDisplayFirstOnly)

setEnvironment(database);

if exist('MaxN','var')~=1
    MaxN = 100;
end
if exist('IsDisplayFirstOnly','var')~=1
    IsDisplayFirstOnly = true;
end

nClasses = length(Names);

% not many classes
if nClasses <= MaxN
    figure;
    h = bar(performance);
    colormap(Colormap);
    ch=get(h,'Children');
    fvd=get(ch,'Faces');
    fvcd=get(ch,'FaceVertexCData');
    for i=1:nClasses
        fvcd(fvd(i,:))=i;
    end
    set(ch,'FaceVertexCData',fvcd);
    
    set(gca,'xtick',[]);

    for i=1:nClasses
        text(i,-0.01,Names{i},'Rotation',270);
    end
    
    ylim([0,1]);
    xlim([0,nClasses+1]);
    title(['Recognition rate: ' num2str(recogRate*100) '%'],'FontSize',20);
else
    M = ceil(nClasses/MaxN);
    if IsDisplayFirstOnly
        M = 1;
    end
    for i = 1:M
        figure;
        range = (i-1)*MaxN+1:min(nClasses,i*MaxN);
        h = bar(performance(range));
        xlim([0,MaxN+0.5]);
        ylim([0,1]);
        map = Colormap(range,:);
        colormap(map);
        ch=get(h,'Children');
        fvd=get(ch,'Faces');
        fvcd=get(ch,'FaceVertexCData');
        for j=1:length(range)
            fvcd(fvd(j,:))=j;
        end
        set(ch,'FaceVertexCData',fvcd);
        
        set(gca,'xtick',[]);
        foo = get(gca,'YLim');
        foo = foo(2)-foo(1);
        daspect([MaxN,foo*5,1]);
        for j=1:length(range)
            text(j,-foo*0.02,Names{range(j)},'Rotation',270,'FontName','Times New Roman','FontSize',6);
        end
        ylim([0,1]);
        set(gca,'YTick',[0 0.2 0.4 0.6 0.8 1]);
        xlim([0,MaxN+1]);
        title(['Recognition rate: ' num2str(recogRate*100) '%'],'FontSize',10);
    end
end