% function to create graph from distance metric

function [nKnn,Knn] = graphFromDist(Dist,K,epsilon)

if exist('K','var')~=1
    K = 5;
end

if exist('epsilon','var')~=1
    epsilon = 0.7;
end
[N,foo] = size(Dist);
if N ~= foo
    error('Dist must be a square matrix!');
end

idx = sub2ind([N,N],1:N,1:N);
Dist(idx) = inf;

nKnn = ones(1,N);
Knn  = cell(1,N);

for i = 1:N
    % sort 
    [~,idx] = sort(Dist(i,:),'ascend');
    idx = idx(1:K); % get the top K
    foo = Dist(i,idx); 
    idx = idx(foo<=epsilon);
    nKnn(i) = length(idx);
    Knn{i}  = idx;
end

