% function to generate image dependent smoothness
function weight=imsmooth(im,epsilon)
if exist('epsilon','var')~=1
    epsilon=1;
end
if ~isfloat(im)
    im=im2double(im);
end
im=imfilter(im,fspecial('gaussian',5,0.67),'same','replicate');
imdx=imfilter(im,[0 -1 1],'same','replicate');
imdy=imfilter(im,[0 -1 1]','same','replicate');

foo=imdx.^2;
if size(foo,3)>1
    foo=sum(foo,3);
end
sigma=2*mean(foo(:));
weight(:,:,1)=(epsilon+exp(-foo/sigma))/(epsilon+1);

foo=imdy.^2;
if size(foo,3)>1
    foo=sum(foo,3);
end
sigma=2*mean(foo(:));
weight(:,:,2)=(epsilon+exp(-foo/sigma))/(epsilon+1);
