% Function to load data
setting = setEnvironment(database);
if exist('Dtraining','var')~=1
    if exist(fullfile(setting.path.database,'database.mat'),'file')~=2
        % Read database structure
        D = LMdatabase(setting.path.annotation);

        % GIST %%%%%%%%%%%%%%%%%%%%%%%%%
        % Read gist features
        gist = LMgist(D, setting.path.images, setting.GISTparam, setting.path.gist);
        
        % HOG2x2 %%%%%%%%%%%%%%%%%%%%%%%
        % Build dictionary of visual words
        setting.VWparamhog = LMkmeansVisualWords(D(1:10:end), setting.path.images, setting.VWparamhog);
        
        % COMPUTE VISUAL WORDS:
        [VWhog, sptHisthog] = LMdenseVisualWords(D, setting.path.images, setting.VWparamhog);
        sptHisthog = sptHisthog';
        
        % GROUND TRUTH SEGMENTS %%%%%%%%
        seg = zeros([256 256 length(D)], 'uint16');
        for i = 1:length(D)
            [foo,seg(:,:,i),names]=LM2segments(D(i),[],setting.path.images,setting.path.LMsegments);
        end
        sptHistObjects = objhist(seg); % build object labels histograms
        sptHistObjects = sptHistObjects';


        % Read test and training indices and split datasets
        load (fullfile(setting.path.database, 'splitTrainingTest.mat'))
        save(fullfile(setting.path.database,'database.mat'),'D','gist','sptHisthog','VWhog','sptHistObjects','testndx','trainingndx');
    else
        load(fullfile(setting.path.database,'database.mat'));
    end

    Dtest = D(testndx);
    gistTest = gist(testndx, :);
    hogTest = sptHisthog(testndx, :);
    objTest = sptHistObjects(testndx, :);

    Dtraining = D(trainingndx);
    gistTraining = gist(trainingndx, :);
    hogTraining = sptHisthog(trainingndx, :);
    objTraining = sptHistObjects(trainingndx, :);
end

fprintf('Database "%s": both training and test data are loaded!\n',setting.database);