#include "Vector.h"

template <class T>
const Vector<T> operator+(const Vector<T>& vect1,const Vector<T>& vect2)
{
	vect1.dimcheck(vect2);
	Vector<T> result(vect1);
	result+=vect2;
	return result;
}

template <class T>
const Vector<T> operator-(const Vector<T>& vect1,const Vector<T>& vect2)
{
	vect1.dimcheck(vect2);
	Vector<T> result(vect1);
	result-=vect2;
	return result;
}

template <class T>
const Vector<T> operator*(const Vector<T>& vect1,const Vector<T>& vect2)
{
	vect1.dimcheck(vect2);
	Vector<T> result(vect1);
	result*=vect2;
	return result;
}

template <class T>
const Vector<T> operator/(const Vector<T>& vect1,const Vector<T>& vect2)
{
	vect1.dimcheck(vect2);
	Vector<T> result(vect1);
	result/=vect2;
	return result;
}

template <class T>
const Vector<T> operator+(const Vector<T>& vect,double val)
{
	Vector<T> result(vect);
	result+=val;
	return result;
}

template <class T>
const Vector<T> operator-(const Vector<T>& vect,double val)
{
	Vector<T> result(vect);
	result-=val;
	return result;
}

template <class T>
Vector<T> operator*(const Vector<T>& vect,double val)
{
	Vector<T> result(vect);
	result*=val;
	return result;
}

template <class T>
const Vector<T> operator/(const Vector<T>& vect,double val)
{
	Vector<T> result(vect);
	result/=val;
	return result;
}

template <class T>
double innerproduct(const Vector<T>& vect1,const Vector<T>& vect2)
{
	vect1.dimcheck(vect2);
	double result=0;
	for(int i=0;i<vect1.nDim;i++)
		result+=vect1.pData[i]*vect2.pData[i];
	return result;
}
