#include <QtGui/QApplication>
#include <QString>
#include "integrateannotation.h"
#include "Vector.h"
#include "Image.h"
#include "project.h"
#include "string.h"
#include "PairwiseBP.h"

int LoadPriors(Image<double>*& pImPriors,char**& pNames);

int main(int argc, char *argv[])
{
	QApplication a(argc, argv);
	Image<double>* pImPriors=NULL;
	char** pNames=NULL;
	int numObjects=0;
	
	numObjects=LoadPriors(pImPriors,pNames);
	
	PairwiseBP bp;
	bp.LoadDataTerm(numObjects,pImPriors);

	bp.LoadSmoothness(0.5);

	bp.MessagePassing(200);

	bp.OutputResult("PriorSeg.dat");

	_Release1DBuffer(pImPriors);
	_Release2DBuffer(pNames,numObjects);
	return 1;
}

int LoadPriors(Image<double>*& pImPriors,char**& pNames)
{
	FILE* fp;
	if((fp=fopen("prior/names.txt","r"))==NULL)
	{
		cout<<"Error in loading files!"<<endl;
		return 0;
	}
	char string[128];
	int numObjects=0;
	while(!feof(fp)){
		fscanf(fp,"%s\n",string);
		//printf("%s\n",string);
		numObjects++;
	}
	fclose(fp);
	// allocate buffer
	pNames=new char*[numObjects];
	for(int i=0;i<numObjects;i++)
		pNames[i]=new  char[128];
	pImPriors=new Image<double>[numObjects];

	// load images and strings
	fp=fopen("prior/names.txt","r");
	for(int i=0;i<numObjects;i++)
	{
		fscanf(fp,"%s\n",pNames[i]);
		strcpy(string,"prior/");
		strcat(string,pNames[i]);
		strcat(string,".dat");
		printf("%s\n",string);
		if(!pImPriors[i].readImage(QString(string)))
			cout<<"Error in reading "<<string<<endl;
		for(int j=0;j<pImPriors[i].nelements();j++)
			pImPriors[i].data()[j]=-log(pImPriors[i].data()[j]);
	}

	return numObjects;
}