% procedure to see how alpha affects the overall performance of the system

if exist('alphaCurve.mat','file')~=2
    optParaDefault = {'nCandidates',7,...
                                 'nNeighbors',40,...
                                 'prior_weight',0,...
                                 'spatial_weight',0,...
                                 'isDisplay',false,...
                                 'isPrint',true,...
                                 'alpha',1};

    [recogRate(:,1),alphaRange] = testAlpha('dataset1',optParaDefault);

    optParaDefault{6} = 0.1; % prior_weight
    optParaDefault{8} = 60; % spatial_weight

    [recogRate(:,2),alphaRange] = testAlpha('dataset1',optParaDefault);
    save('alphaCurve.mat','alphaRange','recogRate');
else
    load('alphaCurve.mat');
end

figure;
plot(alphaRange,recogRate(:,1),'-bs','LineWidth',2,'MarkerFaceColor','b');hold on;
plot(alphaRange,recogRate(:,2),'-ro','LineWidth',2,'MarkerFaceColor','r');
ylim([0.55,0.8]);
set(gca,'FontSize',24,'FontName','Times New Roman');
legend('\alpha = 0, \beta = 0', '\alpha = 0.1, \beta = 60','Location','SouthEast');
xlabel('Regularization coefficient \lambda');
ylabel('Average pixel-wise recognition rate');
set(gca,'XTick',0:0.25:1.5);
saveas(gcf,'lambdaEffect.eps','psc2');