% function to plot the performance of the SIFT flow matching algorithm
alpha = 0.7;
database = 'datasetSUN';
% database = 'dataset1';
method = 'hog';
% method = 'gistL2';
setting = setEnvironment(database);
srcpath = setting.path.recog.performanceNoRate;

color_array=[0 0 255;...
            1 206 45;...
             255 0 0;...
             4 207 234;...
             255 0 255;...
             0 200 0;...
             255 128 0];
color_array=color_array/255;         
marker_array={'*-','o-','x-','s-','d-','*-','o-','x-'};
K_array=[1 5:5:120];
nCandidates_array=[3 5 7 9 11 13 15];
textarray=[];
figure;
for j=1:length(nCandidates_array)
    nCandidates=nCandidates_array(j);
    x=[];y=[];
    for i=1:length(K_array)
        file=dir(fullfile(srcpath,['method=' num2str(method) ' alpha=' num2str(alpha) ' nCandidates=' num2str(nCandidates) ' K=' num2str(K_array(i)) '.mat']));
        if ~isempty(file)
            load(fullfile(srcpath,file.name));
            x(end+1)=K_array(i);
            y(end+1)=recogArray(prior_idx,spatial_idx);
        end
    end
    if ~isempty(x)
        plot(x,y,marker_array{j},'LineWidth',3,'MarkerSize',6,'Color',color_array(j,:),'MarkerFaceColor',adjustSaturation(color_array(j,:),2,2));
        hold on;
        textarray{j}=['M=' num2str(nCandidates)];
    end
end

xlim([1,K_array(end)]);
switch database
    case 'datasetSUN'
        ylim([0.3,0.5]);
    case 'dataset1'
        ylim([0.65,0.8]);
end
legend(textarray,4);
set(gca,'FontSize',24,'FontName','Times');
xlabel('Number of nearest neighbors K');
%ylabel('Recognition rate');
%set(gca,'XTick',[1 10 20 30 40 50 60 70 80 90,100]);
%set(gca,'XTick',[1 20 40 60  80  100 120 140 160]);
set(gca,'XTick',[1 20 40 60  80  100 120]);
foo = datestr(now);
foo = regexprep(foo,':','.');
saveas(gcf,fullfile(setting.path.eps,[database ' method=' method ' time=' foo ' evalPerformance.eps']),'psc2');