% function to plot the gain of having prior and spatial terms in the
% objective function

K_array=[5 10 15 20 25 30 35 40 45 50 55 60];
nCandidates_array=5;
nCandidates=5;

if exist('recogRateZero.mat','file')~=2
    for j=1:length(nCandidates_array)
        nCandidates=nCandidates_array(j);
        for i=1:length(K_array)
            K=K_array(i);
            recogRateZero(j,i)=objectRecognition(nCandidates,K,0,0);
        end
    end
    save('recogRateZero.mat','recogRateZero');
else
    load('recogRateZero.mat');
    recogRateZero=recogRateZero(1,:);
end

%return;

%plot(K_array,recogRateZero,'-o','Color',[108 0 36]/255,'LineWidth',2);hold on;
plot(K_array,recogRateZero,'-bo','LineWidth',3,'MarkerSize',6);hold on;

% load the precomputed optimal recognition rate

x=[];y=[];
srcpath='performanceNoRate/';
for i=1:length(K_array)
    file=dir(fullfile(srcpath,['nCandidates=' num2str(nCandidates) ' K=' num2str(K_array(i)) '.mat']));
    if ~isempty(file)
        load(fullfile(srcpath,file.name));
        x(end+1)=K_array(i);
        y(end+1)=recogArray(prior_idx,spatial_idx);
    end
end

plot(x,y,'-r*','LineWidth',3,'MarkerSize',6);
legend('without prior and spatial terms','with prior and spatial terms',4);
set(gca,'FontSize',24,'FontName','Times');
xlabel('Number of nearest neighbors K');
%ylabel('Recognition rate');
ylim([0.6 0.76]);
set(gca,'XTick',[1 10 20 30 40 50 60]);
saveas(gcf,'eps/PriorSpatialGain.eps','psc2');