if exist('array','var')~=1
    if exist('testRatioArray.mat','file')~=2
        [rate,array]=objectRecognition('dataset1','nCandidates',9,'nNeighbors',85,'epsilon',5,'isDisplay',false,'spatial_weight',20,'prior_weight',0.06);
        save('testRatioArray.mat','array');
    else
        load('testRatioArray.mat');
    end
end

for i = 1:length(array)
    energy(i) = array(i).energy;
    rate(i) = array(i).rate;
    nPixels(i) = array(i).nPixels;
    nCorrect(i) = array(i).nCorrect;
    dist(i) = mean(array(i).dist);
end

ratio = (1:length(array))/length(array);

figure;
%plot([0,ratio],ones(1,length(array)+1)*sum(nCorrect)/sum(nPixels),'g','LineWidth',2);hold on;

[foo,idx] = sort(rate,'descend');
plot(ratio,cumsum(nCorrect(idx))./cumsum(nPixels(idx)),'--k','LineWidth',2);hold on;
line([0.001,0.999],[1 1]*sum(nCorrect)/sum(nPixels),'LineWidth',2,'Color','g','HandleVisibility','off');

% sort by the objective function
[foo,idx] = sort(energy,'ascend');
plot(ratio,cumsum(nCorrect(idx))./cumsum(nPixels(idx)),'r','LineWidth',2);

[foo,idx] = sort(dist,'ascend');
plot(ratio,cumsum(nCorrect(idx))./cumsum(nPixels(idx)),'b','LineWidth',2);




set(gca,'FontName','Times New Roman','FontSize',24);
xlabel('Top percentage of test data w.r.t. metric');
%ylabel('Recognition rate','FontName','Times New Roman','FontSize',20);

legend('Recognition rate','Parsing objective','GIST','Location','SouthEast');
saveas(gcf,'testRatio.eps','psc2');