% function to plot the performance as a function w.r.t. the training ratio
function recogRate = plotTrainingRatio(trainingRatio,nTrials)
if exist('nTrials','var')~=1
    nTrials = 15;
end

recogRate = zeros(1,nTrials);
fprintf('Training ratio: %f\n',trainingRatio);
if trainingRatio<1
    for j = 1:nTrials
        recogRate(j) = objectRecognition('dataset1','nCandidates',9,'nNeighbors',85,'epsilon',6,'isDisplay',false,'spatial_weight',20,'prior_weight',0.06,...
                                         'isPrint',false,'isSaveEps',false,'isOverwriteLikelihoodFile',true,'trainingRatio',trainingRatio);
        fprintf('No.%d Recognition rate: %f\n',j,recogRate(j));
    end
else
    foo = objectRecognition('dataset1','nCandidates',9,'nNeighbors',85,'epsilon',6,'isDisplay',false,'spatial_weight',20,'prior_weight',0.06,...
                                         'isPrint',false,'isSaveEps',false,'isOverwriteLikelihoodFile',true,'trainingRatio',trainingRatio);
    recogRate = repmat(foo,[1,nTrials]);
end
fprintf('\n');
setting =setEnvironment('dataset1');
dstpath = fullfile(setting.path.database,'trainingRatio');
if exist(dstpath,'dir')~=7
    mkdir(dstpath);
end
save(fullfile(dstpath,['trainingRatio=' num2str(trainingRatio) '.mat']),'recogRate');



