function [nCores,computername] = setMultiThread(nCores)
if ispc
    computername = lower(getenv('COMPUTERNAME')); 
else
    [~,computername] = unix('hostname');
end
if exist('nCores','var')~=1
    switch computername
        case 'celiu-x220'
            nCores = 4;
        case 'celiu-dell'
            nCores = 8;
        case 'celiu-w510'
            nCores = 8;
        case 'Ce-Liu-MacBook-Pro.local'
            nCores = 4;
        otherwise 
            nCores = 4;
    end
end

if nCores>1
    if matlabpool('size') ~= nCores
        if matlabpool('size')>0
            matlabpool close;
        end
        matlabpool(nCores);
    end
end
