function showColorLCH(lch, LCHparam)

% get colors for each bin:
ab = LCHparam.bincenters;
lab = cat(2,20*ones(size(ab,1),1), ab);
C = makecform('lab2srgb');
rgb = applycform(double(lab),C);
rgb = rgb./repmat(max(rgb,[],2), [1 size(rgb,2)]); % increase saturation

% colorize each map:
lch = reshape(lch, [size(lch,1) size(lch,2) 1 size(lch,3)]);
lch = repmat(lch, [1 1 3 1]);

n = LCHparam.num_spt_bins;
for i = 1:size(lch,4)/n^2
    for k = 0:n^2-1
        s = LCHparam.mum_color_bins*k;
        m = squeeze(lch(:,:,1,i+s));
        lch(:,:,1,i+s) = m*rgb(i,1);
        lch(:,:,2,i+s) = m*rgb(i,2);
        lch(:,:,3,i+s) = m*rgb(i,3);
    end
end
lch = lch/max(lch(:));
figure
montage(lch)

