% function to warp segmentation according to the flow field
% the difference between this function and warpImage is that 'nearest'
% interpolation is used instead of 'cubic'.
% written by Ce Liu

function warpI2=warpSegmentation(im,vx,vy)

[height2,width2,nchannels]=size(im);
[height1,width1]=size(vx);

[xx,yy]=meshgrid(1:width2,1:height2);
[XX,YY]=meshgrid(1:width1,1:height1);
XX=XX+vx;
YY=YY+vy;
mask=XX<1 | XX>width2 | YY<1 | YY>height2;
XX=min(max(XX,1),width2);
YY=min(max(YY,1),height2);

for i=1:nchannels
    foo=interp2(xx,yy,im(:,:,i),XX,YY,'nearest');
    %foo(mask)=0;
    warpI2(:,:,i)=foo;
end